import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import javax.jdo.annotations.Index;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.FlushModeType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Persistence;
import javax.persistence.Query;

public final class QueryInternalExceptionI260 {

	public static void main(String[] args) {
		System.out.println("start");
		EntityManagerFactory emf = Persistence
				.createEntityManagerFactory("objectdb:$objectdb/db/test.tmp;drop");
		EntityManager em = emf.createEntityManager();
		em.setFlushMode(FlushModeType.AUTO);

		em.getTransaction().begin();

		int count = 30000;
		
		for (int k = 0; k < 2; k++) {
			CodeCovPropImpl ccp = new CodeCovPropImpl("123");
			em.persist(ccp);
			CovRecImpl b = new CovRecImpl();
			for (int i = 0; i < count; i++) {
				if (i % 50 == 0) {
					ccp = new CodeCovPropImpl("123");
					em.persist(ccp);
				}
				CoveMeasurImpl cm = new CoveMeasurImpl();
				cm.setCovProp(ccp);
				b.addCovMeasur(cm);
			}
			System.out.print("-");
			em.persist(b);
			em.getTransaction().commit();
			System.out.println("commited");
			em.getTransaction().begin();
		}

		System.out.println("query works:");

		String select = "SELECT DISTINCT property.uid FROM CovPropImpl AS property, CovRecImpl AS record ";
		
		String whereOk = "WHERE 3<>4 AND property.uid MEMBER OF record.properties";
		String whereEx = "WHERE property.uid MEMBER OF record.properties";
		
		String queryString_Ok = select + whereOk;
		String queryString_Ex = select + whereEx;

		Query query = em.createQuery(queryString_Ex);
		List result = query.getResultList();
		System.out.println("size: " + result.size() + "");

		em.getTransaction().commit();

		em.close();
		emf.close();
	}

	@Entity
	static public abstract class MElementImpl {

	    @Id
	    private String uid;

	    protected MElementImpl() {
	       uid = UUID.randomUUID().toString().toUpperCase();
	    }

		public String getUid() {
			return uid;
		}
	}
	
	@Entity
	static public class CoveMeasurImpl extends MElementImpl {

	    @Basic
	    private int propertyCoverageCounter;
	    @ManyToOne (targetEntity = CovPropImpl.class)
	    private CovPropImpl coverageProperty;
	    
	    CovPropImpl getCovProp(){
	    	return coverageProperty;
	    }

		public void setCovProp(CovPropImpl coverageProperty) {
			this.coverageProperty = coverageProperty;
		}
	}
	
	@Entity
	static public class CovPropImpl extends MElementImpl {

	    @Index
	    @Basic
	    private String scopeID; // redundant, just as aid for efficient queries

	    protected CovPropImpl() {
	    }
	    
	    public CovPropImpl(String scopeID) {
	        this.scopeID = scopeID;
	    }
	}
	
	@Entity
	static public class CovRecImpl extends MElementImpl {

	    @Basic
	    private String vectorId;
	    @OneToMany (targetEntity = CoveMeasurImpl.class, cascade = {CascadeType.ALL })
	    private Set<CoveMeasurImpl> covMeasurs = new HashSet<>();
	    @Basic
	    private List<String> properties = new ArrayList<>(); // redundant, just as aid for efficient queries

	    public void addCovMeasur(CoveMeasurImpl covMeasur) {
	        covMeasurs.add(covMeasur);
	        properties.add(covMeasur.getCovProp().getUid());
	    }
	}
	
	@Entity
	static public class CodeCovPropImpl extends CovPropImpl {
		protected CodeCovPropImpl() {
	        super();
	    }
	    public CodeCovPropImpl(String scopeID) {
	        super(scopeID);
	    }
	}
}